//Bibliotecas
#include <BluetoothSerial.h>
#include <ESP32Servo.h>
#include <Adafruit_Sensor.h>
#include <DHT.h>

#define DHTTYPE DHT22

Servo myServo;

BluetoothSerial SerialBT;

//LED's
const int garagem = 19;
const int cozinhaLed1 = 18;
const int cozinhaLed2 = 21;
const int quarto = 5;
const int banheiro = 22;
const int sala = 4;
const int varanda = 2;

//Cooler
const int salaCooler = 15;

//DH11
const int cozinhaSens = 27;

//ServoMotor
const int garagemPorta = 14;

//magnet sens
const int janelaSens = 13;

int valServo;

int magState = 0;

int dadoRecebido;

DHT dht(cozinhaSens, DHTTYPE);

void setup() {
  //inicializações
  //Serial Monitor
  Serial.begin(115200);
  //inicialização do Bluetooth
  SerialBT.begin("PLACA ESP32");

  //inicialização do dht22
  dht.begin();

  //inicialização do servo
  myServo.attach(garagemPorta);
  myServo.write(0);

  //Led's
  pinMode(garagem, OUTPUT);
  pinMode(cozinhaLed1, OUTPUT);
  pinMode(cozinhaLed2, OUTPUT);
  pinMode(quarto, OUTPUT);
  pinMode(banheiro, OUTPUT);
  pinMode(sala, OUTPUT);
  pinMode(varanda, OUTPUT);
  pinMode(salaCooler, OUTPUT);

  //Sensores e Servo
  pinMode(garagemPorta, OUTPUT);
  pinMode(cozinhaSens, OUTPUT);
}

void loop() {

  //programação do imã
  magState = digitalRead(janelaSens);

  if (magState == HIGH) {
    digitalWrite(cozinhaLed2, HIGH);
    Serial.print("on");
  }
  else {
    digitalWrite(cozinhaLed2, LOW);
    Serial.print("off");
  }


  if (SerialBT.available()) {

    //programação do dht22
    float umidade = dht.readHumidity();
    float temperatura = dht.readTemperature();
    float hic = dht.computeHeatIndex(temperatura, umidade, false);

    if (!isnan(umidade) && !isnan(temperatura)) {
      String hicStr = String(hic);
      String temperatura = String(temperatura);
      String umidade = String(umidade);

      SerialBT.print(temperatura);
      SerialBT.print("$");
      SerialBt.print(umidade);
      SerialBt.println("$")

    }else {
      Serial.println("Não foi possível ler o dado do DHT!");
    }

    dadoRecebido = SerialBT.read();
    
    int botao = floor(dadoRecebido / 10);
    int valor = dadoRecebido % 10;

    switch (botao) {
      case 1:
        Serial.print("Botão 1 (Garagem):"); Serial.print(valor);
        digitalWrite(garagem, valor);
        break;

      case 2:
        Serial.print("Botão 2 (cozinha 1):"); Serial.print(valor);
        digitalWrite(cozinhaLed1, valor);
        break;

      case 3:
        Serial.print("Botão 3 (cozinha 2):"); Serial.print(valor);
        break;
      case 4:
        Serial.print("Botão 4 (quarto): "); Serial.print(valor);
        digitalWrite(quarto, valor);
        break;

      case 5: 
        Serial.print("Botão 5 (banheiro): "); Serial.print(valor);
        digitalWrite(banheiro, valor);
        break;

      case 6:
        Serial.print("Botão 6 (sala):"); Serial.print(valor);
        digitalWrite(sala, valor);
        break;

      case 7:
        Serial.print("Botão 7 (varanda):"); Serial.print(valor);
        digitalWrite(varanda, valor);
        break;

      case 8:
        Serial.print("Botão 8 (cooler):"); Serial.print(valor);
        digitalWrite(salaCooler, valor);
        break;

      case 9: 
        Serial.print("Botão 9 (garagem porta): "); Serial.print(valor);

        myServo.attach(garagemPorta);

        if(valor == 1) {
          myServo.write(180);
          delay(15);
        }else {
          myServo.write(90);
          delay(15);
          }
        digitalWrite(garagemPorta, valor);
        break;

    }
  }
}


